	<TABLE BGCOLOR=C0C0C0 ALIGN=RIGHT WIDTH=200 BORDER=2 CELLSPACING=0 CELLPADDING=2>
	<TR><TD COLSPAN=3 BGCOLOR=7F7FFF ALIGN=CENTER><FONT FACE="Primer Print" COLOR=000000 SIZE=+3><B>News</B></FONT></TD></TR>
	<TR><TD BGCOLOR=C0C0C0 COLSPAN=3 ALIGN=LEFT><FONT FACE="MS Sans Serif, Arial" SIZE=-1>
		I am not actively updating this site because I am writing content for it.  The current content I am working on is a book to be published for <U>free</U> on the web.  For more information see <A HREF="<?echo(meu('cppbegguide'));?>">Neil's Guide to C++</A>.<BR>
		<BR>
	</FONT></TD></TR>
	<TR><TD ALIGN=CENTER BGCOLOR=C0C0C0><?echo(rndilnk());?></TD><TD ALIGN=LEFT WIDTH=100% BGCOLOR=C0C0C0><FONT FACE="MS Sans Serif, Arial" SIZE=-2>
		&nbsp;Update:&nbsp;October&nbsp;15th,&nbsp;2001
	</FONT></TD><TD ALIGN=RIGHT BGCOLOR=C0C0C0><IMG SRC="gfx/table/cornpull.gif"></TD></TR>

	</TABLE>

	Welcome to NeilStuff.com, the home of <B><A HREF="<?echo(meu('cpp'));?>">Neils C++ Stuff</A></B>.<BR>
	<BR>
	Common issues:<BR>
	<UL>
		<LI><A HREF="#coltext">How to I print colored text in C++?</A>
		<LI><A HREF="#dothis">Can I do <I>this</I> in C++?</A>
		<LI><A HREF="<?echo(meu('cppsoft'));?>">I want a free C++ compiler.</A>
		<LI><A HREF="<?echo(meu('cppbuilder'));?>">I am having trouble getting/installing/using the free Borland Builder C++ compiler</A>.
		<LI><A HREF="<?echo(meu('oldcpptut'));?>">I am looking for free C++ tutorials.</A>
		<LI><A HREF="<?echo(meu('cpplinks'));?>">I am looking for links to other C++ web pages.</A>
		<LI><A HREF="<?echo(meu('qa'));?>">I have a question pertaining to C++.</A>
		<LI><A HREF="<?echo(meu('service'));?>">I need help with a school assignment or programming project.</A>
	</UL>

	<A NAME="coltext"><H2> Colored text in C++ </H2></A>

	I get this question <I>a lot</I> (if you asked this once before and I never replied it's because I get tired of answering) and strangely enough, it's not addressed in very many places.  In fact, most web sites, people, books, newsgroups, F.A.Q.'s etc. will tell you this first: <I>there is no standard in C++ for colored text</I>.  But don't fret, it can be done.  The reason for this "lacking" feature is because the console (or standard) input/output functionality has no concept of formatting in any sense.  When printing text, characters, or arbitrary bytes using '<CODE>cout</CODE>' or '<CODE>printf()</CODE>' (or other standard i/o functionality) it has no knowledge of what device the data is going to.  These methods are used simply to dump data into something else, most typically the screen.<BR>
	<BR>
	Many of the resulting depots for data dumped through standard output are either files or the screen.  Most people figure that '<CODE>cout</CODE>' and '<CODE>printf()</CODE>' always write text to the screen, since that's what happens when they run their program in a command console or through their compiler.  This is simply not true.  If you're running your program on a DOS or Windows-based machine, try running your program with the command-line parameters "<CODE>&gt; out.txt</CODE>".  Like this:<BR>
	<BR>
	<CODE><B>C&gt; myprog &gt; out.txt</B></CODE><BR>
	<BR>
	Notice that your program no longer prints its text output to the screen.  Rather the output has now been directed to the file "<CODE>out.txt</CODE>".  Now you see why their can't be a standard way to color text.<BR>
	<BR>
	Colored text, however, is not impossible.  You must call upon functionality that is specific to the device that the text is being printed to.  In your case this is the command-console, but coloring the text in a command-console differs between OS's (even between DOS and seemingly DOS-duplicate consoles).  Thus, you'll need to write <I>operating system specific</I> source code in order to perform the coloring.  This is not as hopeless as it sounds.<BR>
	<BR>
	I'm currently planning on writing a simple, <I>portable</I> header file that you can include into programs to perform text coloring.  It will work for Windows and DOS-based target platforms.  If a platform is not supported, it will simply not perform any coloration.  Be patient, I'm working on completing this soon but it isn't done yet.  I'm currently working with <A HREF="http://msdn.microsoft.com/library/en-us/dllproc/conchar_1mcz.asp">Windows platform code</A>.  I have no release date as yet as I am <I>very</I> busy.  If you <I>really</I> want this please send me an email.  If I get enough requests I'll take it seriously and make it a priority.<BR>
	<BR>
	Please be patient and don't send me any more emails with this question.<BR>
	<BR>

	<A NAME="dothis"><H2> Can I do <I>this</I> in C++? </H2></A>
	
	If you ever wonder if something is possible in C or C++ you must always assume the answer is yes.  Any language that has access to a machine at its native level can do anything that the machine is capable of.  The question no longer becomes <I>if</I> something is possible, but <I>how</I> it is done.<BR>
	<BR>
	
	<BR><BR><BR><BR><BR><BR><BR><BR>
	<TABLE WIDTH=100% BORDER=0 CELLSPACING=0 CELLPADDING=0><TD ALIGN=RIGHT>
	<!-- Start of TheCounter.com Code -->
	<SCRIPT TYPE="text/javascript" LANGUAGE="javascript">
	s="na";c="na";j="na";f=""+escape(document.referrer)
	</SCRIPT>
	<SCRIPT TYPE="text/javascript" LANGUAGE="javascript1.2">
	s=screen.width;v=navigator.appName
	if (v != "Netscape") {c=screen.colorDepth}
	else {c=screen.pixelDepth}
	j=navigator.javaEnabled()
	</SCRIPT>
	<SCRIPT TYPE="text/javascript" LANGUAGE="javascript">
	function pr(n) {document.write(n,"\n");}
	NS2Ch=0
	if (navigator.appName == "Netscape" &&
	navigator.appVersion.charAt(0) == "2") {NS2Ch=1}
	if (NS2Ch == 0) {
	r="&size="+s+"&colors="+c+"&referer="+f+"&java="+j+""
	pr("<A HREF=\"http://www.TheCounter.com\" TARGET=\"_top\"><IMG"+
	" BORDER=0 SRC=\"http://c2.thecounter.com/id=1450277"+r+"\"><\/A>")}
	</SCRIPT>
	<NOSCRIPT><A HREF="http://www.TheCounter.com" TARGET="_top"><IMG
	SRC="http://c2.thecounter.com/id=1450277" ALT="TC" BORDER=0></A>
	</NOSCRIPT>
	<!-- End of TheCounter.com Code -->
	</TD></TABLE>

<!--
	Welcome to the next evolution of the modestly popular <B><A HREF="<?echo(meu('cpp'));?>">Neil's C++ Stuff</A></B> which is still the primary focus of this site.  However, I will be expanding outside of just free C++ resources, books, and such.<BR>
	<BR>
	My long term goal is to provide more than just a few free C++ tutorials and articles, but a whole, online center of computer and programming resources.  Things that I myself am using ... or learning!  More languages, tons of example programs, detailed walk-throughs, instructions for specific software, etc.  Compared to my dream of it, the place is pretty drab so far.  But it will grow with your and others support!<BR>
	<BR>
	The site structure itself was thrown together from scratch in a day.  It isn't yet the fully featured "version 2" yet (moderated source control for multiple authors, automatic site updating, modification reversal, etc.), but it had to be done so I could actually conceivably <I>update</I> this thingamabob.<BR>
	<BR>
	I'm also still providing <B>high quality <A HREF="<?echo(meu('service'));?>">services</A> at competitive prices</B>.  So if you need something completed, <A HREF="<?echo(meu('contact'));?>">let me know</A>.<BR>
	<BR>
	<TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 BGCOLOR=WHITE><TD><TABLE BORDER=0 CELLSPACING=0 CELLPADDING=4 BGCOLOR=WHITE>
	<TD ALIGN=LEFT VALIGN=TOP><IMG SRC="gfx/promo/cipher_cover.jpg" ALT="Cover" WIDTH=200 HEIGHT=200></TD>
	<TD ALIGN=LEFT VALIGN=TOP><IMG SRC="gfx/promo/cipher_text.jpg" ALT="Cipher" WIDTH=104 HEIGHT=40><BR>
		Take a harmonious listen to the first CD by <A HREF="http://www.alphaconspiracy.com/">the alpha conspiracy</A>.  I am <B>not</B> a paid sponsor, but an inspired fan.  I wanted to do my part in promoting this magnificent album.  This is a great CD by a highly respectable independent artist.  It's hard to categorize this music (especially my personal favorite, "<I>Martian Lovesong</I>"), but if you enjoy any kind of electronica (Orbital, Underworld, etc.), I think you'll thoroughly enjoy this CD!  All of the procedes will go into the promotion of the music and the production of the next album.  For a free taste of this pleasurable conspiracy, wander over to the <A HREF="http://www.alphaconspiracy.com/">alphaconspiracy.com</A> or <A HREF="http://www.mp3.com/alphaconspiracy">their page on MP3.com</A>.
	</TD>
	</TABLE></TD></TABLE>
-->
	<!--
	<CENTER><TABLE><FORM NAME=t METHOD=POST ACTION="https://www.cafepress.com/cp/checkout/checkout.jsp" ONSUBMIT="fixsize();">
	<TR><TD COLSPAN=3 ALIGN=CENTER><FONT SIZE=+1>Show your support!  Buy a cool T-Shirt for $19!</FONT></TD>
	<TR><TD ALIGN=CENTER VALIGN=TOP><IMG SRC="gfx/promo/tshirtf.gif" WIDTH=235 HEIGHT=180><BR><FONT SIZE=-1 FACE="Arial,Sans Serif"><B>front</B></FONT></TD>
	<TD>
	Show off your bulging muscles and luxurious curves beneath the soft cotton fabric of a <B>NeilStuff T-Shirt</B>.  Click "Gimme" to purchase a large T-Shirt and you'll be taken to a <I>secure</I> order form at the prestigious <A HREF="http://www.cafepress.com/">CafePress</A>.<BR>
	<BR>
	<CENTER>
		<INPUT TYPE=HIDDEN NAME="cp_neilstuff-tshirt-large" VALUE=1>
		<INPUT TYPE=SUBMIT VALUE="Gimme"><BR>
		<FONT SIZE=-1 FACE="Arial,Sans Serif"><A HREF="<?echo(meu('promo'));?>">more sizes and products</A></FONT>
	</CENTER>
	</TD>
	<TD ALIGN=CENTER VALIGN=TOP><IMG SRC="gfx/promo/tshirtb.gif" WIDTH=235 HEIGHT=185><BR><FONT SIZE=-1 FACE="Arial,Sans Serif"><B>back</B></FONT></TD></TR>
	</FORM></TABLE></CENTER>
	-->



<!--

	Beyond this site I am open to provide <A HREF="service.php">high quality services</A> for good prices.  I'm also bringing back the old <A HREF="qa.php">Q&A</A> so I'll actually have something to put in my <A HREF="news.php">newsletter</A>.  I'd like to concentrate on improving this site now, but I also have to pay rent.  If you're a cheapy, just click on a banner link at the <A HREF="#sponsor">bottom</A> of this page.<BR>
	<BR>
	I'm still writing the specification for a full-blown version 2 of this site which will be <I>extremely</I> dynamic and pampered.  By that I mean I'll be able to sit back and scratch my nu- er chin while writing half-assed <A HREF="tut.php">articles</A> in plain text -- and they'll come out prettier'n pie!<BR>
	<BR>
	Lastly before you run off to read stuff on this site I'd like to thank Ryan (aka <A HREF="http://www.cleptoscastle.com/">Clepto</A>) for hosting this site on it's new domain!  Yay!<BR>
	<BR>
-->
