/**[assign1.cpp]****************************************************************

Assignment #1: Functions - Lowest Score Drop

Write a program to calculate the average of a series of test scores
where the lowest score in the series is dropped.  It should use the
following functions:

- GetValues should ask for five test scores and store them in variables.

- FindLowest should determine which of the five scores is the lowest, and
  return that value.

- CalcAverage should calculate and display the average of the four
  highest scores.

Input Validation: - Do not accept test scores higher than 100 or lower
than 0.

*******************************************************************************/
#include <iostream.h>

int scores[5];

void GetValues(void);
int FindLowest(void);
void CalcAverage(int lowest);

int main()
{
	int lowest;

	GetValues();
	
	lowest = FindLowest();
	
	CalcAverage(lowest);

	return 0;
}

void GetValues(void)
{
	int i;
	for (i = 0; i < 5; i++)
	{
		cout << "Input test score " << (i+1) << ": ";
		do
		{
			cin >> scores[i];

			if (scores[i] < 0 || scores[i] > 100)
			{
				cout << "Invalid test score!  Must be in range of 0 to 100!"
					 << endl;
			}
		} while (scores[i] < 0 || scores[i] > 100);
	}
}

int FindLowest(void)
{
	int lowest = scores[0];
	int i;

	for (i = 1; i < 5; i++)
	{
		if (scores[i] < lowest)
			lowest = scores[i];
	}

	cout << "Lowest test score is " << lowest << endl;

	return lowest;
}

void CalcAverage(int lowest)
{
	int total = 0;
	int average;
	int i;

	for (i = 0; i < 5; i++)
	{
		if (scores[i] != lowest)
			total += scores[i];
	}

	average = total / 4;

	cout << "Average test score is " << average << endl;
}