//file: card.h

#ifndef Card_H_
#define Card_H_

#include <iostream.h>      // ostream

class Card
{
friend ostream &operator<<(ostream &out, Card &src);

public:
   Card();
   Card(char *newname, char *newphone, int newid);
   Card(Card &src);
   ~Card();

   void Init(char *newname, char *newphone, int newid);
   Card &operator=(Card &src);
   void Print(ostream &out);
   int GetID();
   int GetBook();
   void SetBook(int newbook);
   void Write(ostream &out);

private:
   char *name;             // card holder's name
   char *phone;            // card holder's phone number
   int id;                 // id number of this card
   int book;               // the number of the book checked out (or 0)
};

ostream &operator<<(ostream &out, Card &src);

#endif