@echo off
REM
REM build make for MinGW
REM
REM For this to work, the variable 'debug_flag' in 'main.c' cannot be static.
REM If it is, it will turn up as an unresolved external symbol when linking.
REM

if "%1" == "clear" del *.o
if "%1" == "clear" del glob\*.o
if "%1" == "clear" del w32\*.o
if "%1" == "clear" del w32\subproc\*.o

echo Compiling 'main.c'
if not exist "main.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H main.c -o main.o

echo Compiling 'glob/glob.c'
if not exist "glob/glob.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H glob/glob.c -o glob/glob.o

echo Compiling 'glob/fnmatch.c'
if not exist "glob/fnmatch.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H glob/fnmatch.c -o glob/fnmatch.o

echo Compiling 'w32/pathstuff.c'
if not exist "w32/pathstuff.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H w32/pathstuff.c -o w32/pathstuff.o

echo Compiling 'w32/subproc/sub_proc.c'
if not exist "w32/subproc/sub_proc.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H w32/subproc/sub_proc.c -o w32/subproc/sub_proc.o

echo Compiling 'w32/subproc/w32err.c'
if not exist "w32/subproc/w32err.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H w32/subproc/w32err.c -o w32/subproc/w32err.o

echo Compiling 'w32/subproc/misc.c'
if not exist "w32/subproc/misc.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H w32/subproc/misc.c -o w32/subproc/misc.o

echo Compiling 'alloca.c'
if not exist "alloca.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H alloca.c -o alloca.o

echo Compiling 'getloadavg.c'
if not exist "getloadavg.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H getloadavg.c -o getloadavg.o

echo Compiling 'gettext.c'
if not exist "gettext.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H gettext.c -o gettext.o

echo Compiling 'ar.c'
if not exist "ar.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H ar.c -o ar.o

echo Compiling 'arscan.c'
if not exist "arscan.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H arscan.c -o arscan.o

echo Compiling 'commands.c'
if not exist "commands.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H commands.c -o commands.o

echo Compiling 'dir.c'
if not exist "dir.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H dir.c -o dir.o

echo Compiling 'expand.c'
if not exist "expand.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H expand.c -o expand.o

echo Compiling 'file.c'
if not exist "file.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H file.c -o file.o

echo Compiling 'function.c'
if not exist "function.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H function.c -o function.o

echo Compiling 'getopt.c'
if not exist "getopt.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H getopt.c -o getopt.o

echo Compiling 'implicit.c'
if not exist "implicit.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H implicit.c -o implicit.o

echo Compiling 'job.c'
if not exist "job.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H job.c -o job.o

echo Compiling 'misc.c'
if not exist "misc.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H misc.c -o misc.o

echo Compiling 'read.c'
if not exist "read.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H read.c -o read.o

echo Compiling 'remake.c'
if not exist "remake.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H remake.c -o remake.o

echo Compiling 'rule.c'
if not exist "rule.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H rule.c -o rule.o

echo Compiling 'signame.c'
if not exist "signame.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H signame.c -o signame.o

echo Compiling 'variable.c'
if not exist "variable.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H variable.c -o variable.o

echo Compiling 'vpath.c'
if not exist "vpath.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H vpath.c -o vpath.o

echo Compiling 'default.c'
if not exist "default.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H default.c -o default.o

echo Compiling 'remote-stub.c'
if not exist "remote-stub.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H remote-stub.c -o remote-stub.o

echo Compiling 'version.c'
if not exist "version.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H version.c -o version.o

echo Compiling 'getopt1.c'
if not exist "getopt1.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H getopt1.c -o getopt1.o

REM echo Compiling 'remote-cstms.c'
REM if not exist "remote-cstms.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H remote-cstms.c -o remote-cstms.o

REM echo Compiling 'amiga.c'
REM if not exist "amiga.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H amiga.c -o amiga.o

REM echo Compiling 'vmsfunctions.c'
REM if not exist "vmsfunctions.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H vmsfunctions.c -o vmsfunctions.o

REM echo Compiling 'vmsify.c'
REM if not exist "vmsify.o" gcc -c -I. -I./glob -I./w32/include -DHAVE_CONFIG_H vmsify.c -o vmsify.o

echo.
echo.
echo Building MAKE.EXE
gcc main.o glob/glob.o glob/fnmatch.o w32/pathstuff.o w32/subproc/sub_proc.o w32/subproc/w32err.o w32/subproc/misc.o alloca.o getloadavg.o ar.o arscan.o commands.o dir.o expand.o file.o function.o getopt.o implicit.o job.o misc.o read.o remake.o rule.o signame.o variable.o vpath.o default.o remote-stub.o version.o getopt1.o -o make.exe
