<?include('_base.php');

$p = (int)@$HTTP_GET_VARS['p'];
$map = @$HTTP_GET_VARS['map'];
$uq = @$HTTP_GET_VARS['uq'];

/*****************************************************************************

	Declare Data Types and Functions

*****************************************************************************/

class Item
{
	var $name, $id, $level, $par, $child;
	var $doc;
	var $dir;

	function Item()
	{
		$this->doc = array();
		$this->dir = array();
	}
}

class Map
{
	function Map()
	{
		$this->map = array();
		$this->len = 0;
		$this->level = 0;
		$this->par = -1;
	}

	function In(&$name, &$attrs)
	{
		$this->map[$this->len] = new Item;
		$m =& $this->map[$this->len];
		$m->par = $this->par;
		if ($this->par >= 0)
			$this->map[$this->par]->child++;
		$m->level = $this->level;
		$m->child = 0;
		$keys = array_keys($attrs);
		for ($i = 0; $i < count($keys); $i++)
		{
			$m->{strtolower($keys[$i])} = $attrs[$keys[$i]];
		}
		unset($m);
		$this->par = $this->len;
		$this->level++;
		$this->len++;
	}

	function Out()
	{
		$this->par = $this->map[$this->par]->par;
		$this->level--;
	}
}

function me($i = -1)
{
	global $p;
	if ($i < 0)
		return 'index.php?p=' . $p;
	return 'index.php?p=' . $i;
}

function meu($u)
{
	global $map;
	for ($i = 0; $i < $map->len; $i++)
	{
		if (isset($map->map[$i]->u) && $map->map[$i]->u == $u)
			return 'index.php?p=' . $i;
	}
	return 'index.php?p=0';
}

// random icon (16x16) link
function rndilnk()
{
	return '<A HREF="http://www.gibdon.com/"><IMG SRC="gfx/icon/gm.gif" WIDTH=16 HEIGHT=16 BORDER=0></A>';
/*
	$url = 'http://free.be.com/';
	$ico = 'icon.os/be.gif';

	switch (mt_rand(0,1))
	{
		case 0:
			$url = 'http://free.be.com/';
			$ico = 'icon.os/be.gif';
			break;
		case 1:
			$url = 'http://www.textpad.com/';
			$ico = 'icon/textpad.gif';
			break;
	}

	return '<A HREF="' . $url . '"><IMG SRC="gfx/' . $ico . '" WIDTH=16 HEIGHT=16 BORDER=0></A>';
*/
}

/*****************************************************************************

	Load SiteMap

*****************************************************************************/

$map = new Map;

function startElement($parser, $name, $attrs){$GLOBALS['map']->In(&$name, &$attrs);}

function endElement($parser, $name){$GLOBALS['map']->Out();}

$xml_parser = xml_parser_create();
xml_set_element_handler($xml_parser, "startElement", "endElement");
if (!($fp = fopen("sitemap.xml", "r"))) {
	die("Could not open sitemap.xml");
}

while ($data = fread($fp, 4096)) {
	if (!xml_parse($xml_parser, $data, feof($fp))) {
		die(sprintf("XML error: %s at line %d",
				xml_error_string(xml_get_error_code($xml_parser)),
				xml_get_current_line_number($xml_parser)));
	}
}

xml_parser_free($xml_parser);

/*****************************************************************************

	Globals

*****************************************************************************/

//_[check out unique]_________________________________________________________
//
//
if (isset($uq))
{
	for ($i = 0; $i < $map->len; $i++)
	{
		if (isset($map->map[$i]->u) && $map->map[$i]->u == $uq)
		{
			$p = $i;
			break;
		}
	}
}
//_[check out direct url]_____________________________________________________
//
// This takes a relative url (../folder/doc.htm) and tries to find it in the
// sitemap, based on the page where the relative url was at.
//
else if (isset($du))
{
	if ($du[0] != '#')
	{
		$refl = array();
		$refc = 0;

		//-[seperate folders of url]------------------------------------------
		while (($si = strpos($du, '/')) != false)
		{
			$si++;
			$refl[$refc] = substr($du, 0, $si);
			$refc++;
			$du = substr($du, $si);
		}
		$refl[$refc] = $du;
		$refc++;

		$found = true;

		//-[start at the page's "container"]----------------------------------
		if ($map->map[$p]->child <= 0)
			$p = $map->map[$p]->par;

		//-[move up containers based on '../']--------------------------------
		for ($si = 0; $si < $refc; $si++)
		{
			if ($refl[$si] == '../')
			{
				$p = $map->map[$p]->par;
				if ($p < 0)
					$p = 0;
			}
			else if ($refl[$si] == './' || $refl[$si] == '')
			{
			}
			else
			{
				break;
			}
		}

		//-[find container based on first folder name]------------------------
		//
		// This tries to find the first folder (../folder/doc.htm) as a
		// container in the sitemap.  If it can't, then it moves to the second
		// (if any) and on and on.  The start location for the search for the
		// document will be in the container found.  If none are found then
		// the search will start on the original container.
		//
		if ($si < $refc-1) for ( ; $p != -1; $p = $map->map[$p]->par)
		{
			for ($i = $map->map[$p]->par; $i >= 0 && $i < $map->len; $i++)
			{
				if ($map->map[$i]->id == $refl[$si] &&
					$map->map[$i]->par == $p)
				{
					$p = $i;
					break;
				}
			}

			if ($i < $map->len)
				break;
		}
		else
		{
			$si--;
		}

		//-[search for document in this ($p) container]-----------------------
		if ($p != -1) for ($si++; $si < $refc; $si++)
		{
			if ($refl[$si] == '')
				continue;

			for ($i = $p; $i < $map->len; $i++)
			{
				if ($map->map[$i]->id == $refl[$si] &&
					($map->map[$i]->par == $p ||
					$map->map[$i]->par == $map->map[$i]->par))
				{
					$p = $i;
					break;
				}
			}
		}
		$du = '';

		if ($p == -1)
			$p = 0;
	}
}

$page =& $map->map[$p];

if (!isset($page->name))
	$page->name = 'Untitled';

if (!isset($page->title))
	$page->title = $page->name;

if (!isset($page->quote))
	$page->quote = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';

$menufont = "Lucida Console,Courier New";
$contentfont = 'Verdana,Arial Narrow,Arial,Times New Roman';

if (!isset($page->desc))
	$page->desc = ' ';

$styles =
	"<STYLE TYPE=\"text/css\"><!--\n" .
		"A:hover {text-decoration:underline; color:7F7FFF}\n" .
		".button { font-size:8pt;border-style:solid;border-width:1;width:300px;height:30px; }\n" .
	"--></STYLE>";

$metatags =
	'<META NAME="GENERATOR" CONTENT="TextPad (www.textpad.com) and PHP (www.php.net)">' .
	'<META NAME="AUTHOR" CONTENT="Neil C. Obremski">' .
	'<META NAME="DESCRIPTION" CONTENT="This is my personal dedication to bringing you as much valid information about C++ as I am able; represented by links, tutorials, articles, newsletters, and example source code.">' .
	'<META NAME="KEYWORDS" CONTENT="free, c++, tutorials, examples, source, code, articles">';
/*
if ( (!isset($page->u) || $page->u != 'admin') &&
		isset($_SERVER['REMOTE_PORT']) )
{
	if ($p == 0)
		$valid = 'indexpage';
	else
		$valid = 'sub' . $p;

	$banner2 = '<!-- BEGIN LINKEXCHANGE CODE --><iframe src="http://leader.linkexchange.com/1/X866573/showiframe?" width=468 height=60 marginwidth=0 marginheight=0 hspace=0 vspace=0 frameborder=0 scrolling=no><a href="http://leader.linkexchange.com/1/X866573/clickle" target="_top"><img width=468 height=60 border=0 ismap alt="" src="http://leader.linkexchange.com/1/X866573/showle?"></a></iframe><br><a href="http://leader.linkexchange.com/1/X866573/clicklogo" target="_top"><img src="http://leader.linkexchange.com/1/X866573/showlogo?" width=468 height=16 border=0 ismap alt=""></a><br><!-- END LINKEXCHANGE CODE -->';

	$banner1 =
		"<!-- VC active -->" .
		"<SCRIPT LANGUAGE=\"JavaScript\">\n" .
		"<!--\n" .
		"// ValueParameters\n" .
		"ValueBgColor = \"#C0C0C0\";\n" .
		"ValueLinkColor = \"#007F00\";\n" .
		"ValueAlinkColor = \"#7F7FFF\";\n" .
		"ValueVlinkColor = \"#7F0000\";\n" .
		"ValueHost = \"hs0040699\"\n;" .
		"ValueLoaded = false;\n" .
		"ValueID = \"valueid\";\n" .
		"ValueVersion = \"1.1\";\n" .
		"ValueWidth = 468;\n" .
		"ValueHeight = 60;\n" .
		"//-->\n" .
		"</SCRIPT>" .
		"<SCRIPT LANGUAGE=\"Javascript\" SRC=\"http://oz.valueclick.com/jsmaster\"></SCRIPT>" .
		"<SCRIPT LANGUAGE=\"JavaScript\">\n" .
		"<!--\n" .
		"if (ValueLoaded) ValueShowAd();\n" .
		"//-->\n" .
		"</SCRIPT>" .
		"<NOSCRIPT>" .
		"<A HREF=\"http://kansas.valueclick.com/redirect?host=hs0040699&size=468x60&b={$valid}&v=0\" TARGET=\"_top\"><IMG BORDER=\"0\" WIDTH=\"468\" HEIGHT=\"60\" ALT=\"Click here to visit our sponsor\" SRC=\"http://kansas.valueclick.com/cycle?host=hs0040699&size=468x60&b={$valid}&noscript=1\"></A>" .
		"</NOSCRIPT>" .
		"<!-- vc active -->";
}
else*/
{
	$banner1 = '';
	$banner2 = '';
}

/*****************************************************************************

	Generate Header

*****************************************************************************/

$header =
	'<HTML>' .
	'<HEAD>' .
		'<TITLE>' . $page->title . ' (Neil Stuff)</TITLE>' .
	$styles .
	$metatags .
	'</HEAD>' .
	'<BODY BGCOLOR="EEEEEE" TEXT="000000" LINK="007F00" VLINK="7F0000" ALINK="7F7FFF" MARGINHEIGHT=0 MARGINWIDTH=0 TOPMARGIN=0 LEFTMARGIN=0 BOTTOMMARGIN=0 RIGHTMARGIN=0>' .

	'<TABLE WIDTH=100% BORDER=2 CELLPADDING=0 CELLSPACING=0 BGCOLOR=C0C0C0><TD>' .
		'<TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>' .
		'<TR><TD ALIGN=CENTER COLSPAN=2>' .
			$banner1 .
		'</TD></TR>' .
		'<TR><TD ALIGN=LEFT WIDTH=50%>' .
			'<FONT SIZE=+3 FACE="Arial"><B>' .
			$page->title .
			'</B></FONT><BR>' .
		'</TD>' .
		'<TD ALIGN=RIGHT WIDTH=50%><FONT SIZE=-1 FACE="Arial Narrow"><B>' .
			$page->desc .
		'</B></FONT></TD></TR>' .
		'<TR><TD ALIGN=LEFT COLSPAN=2><FONT FACE="' . $menufont .'" SIZE=-1>[ </FONT>';

$dirlist = '<FONT FACE="' . $menufont .'" SIZE=-1><A HREF="' . me() . '">' . $page->name . '</A></FONT>' . (($page->child>0)?'<FONT FACE="Arial,Sans Serif" SIZE=-1> / </FONT>':' ') . ']</FONT>';
$srcfile = $page->id;
$srcdir = '';

if ($page->par != -1)
{
	for ($i = $page->par; $map->map[$i]->par != -1; $i = $map->map[$i]->par)
	{
		$dirlist = ('<FONT FACE="' . $menufont . '" SIZE=-1><A HREF="' . me($i) . '">' . $map->map[$i]->name . '</A></FONT><FONT FACE="Arial,Sans Serif" SIZE=-1> / </FONT>' . $dirlist);
		$srcfile = ($map->map[$i]->id . $srcfile);
		$srcdir = ($map->map[$i]->id . $srcdir);
	}

	$dirlist = ('<FONT FACE="' . $menufont . '" SIZE=-1><A HREF="' . me(0) . '">' . $map->map[0]->name . '</A></FONT><FONT FACE="Arial,Sans Serif" SIZE=-1> / </FONT>' . $dirlist);
}

$srcfile = ($base . '/' .$srcfile);

$header .= (
	$dirlist .
	'</TD></TR>' .
	'</TABLE></TD></TABLE>'
);

/*****************************************************************************

	Generate Content Shell

*****************************************************************************/

//_[header html of menu]______________________________________________________
$content =
	'<TABLE WIDTH=100% BORDER=0 CELLBORDER=0 CELLSPACING=0 CELLPADDING=5>' .
	'<TR><TD VALIGN=TOP ALIGN=CENTER>' .
	'<TABLE ALIGN=LEFT BGCOLOR=C0C0C0 BORDER=2 CELLSPACING=0 CELLPADDING=2>' .
	'<TR><TD COLSPAN=3 BGCOLOR=7F7FFF ALIGN=CENTER><FONT FACE="Primer Print" COLOR=000000 SIZE=+3><B>Menu</B></FONT></TD></TR>' .
	'<TR><TD BGCOLOR=C0C0C0 COLSPAN=3 ALIGN=LEFT>';

//_[decide who the owner of the menu is]______________________________________
if ($page->child > 0)
	$o = $p;
else
	$o = $page->par;
$owner =& $map->map[$o];

//_[write out menu]___________________________________________________________
for ($i = $o; $i < $map->len; $i++)
{
	$m =& $map->map[$i];
	if ($m->par == $o)
	{
		if ($m->t == '-')
		{
			$content .= '<HR>';
			unset($m);
			continue;
		}

		if (isset($m->ico))
			$icon = $m->ico;
		else if ($m->child > 0)
			$icon = 'icon/folder.gif';
		else
			$icon = 'icon.map/' . $m->t . '.gif';

		$content .=
			'<A HREF="' . me($i) . '"><IMG SRC="gfx/' . $icon . '" WIDTH=16 HEIGHT=16 BORDER=0></A><FONT FACE="Arial,Sans Serif" SIZE=-1>&nbsp;<A HREF="' . me($i) . '">' . str_replace(' ', '&nbsp;', $map->map[$i]->name) . '</A></FONT><BR>';
	}
	unset($m);
}

//_[back page is always the parent of the menu owner]_________________________
//
// Neil don't be stupid and try to change this ... it's RIGHT this time!
//
$back = $map->map[$o]->par;

if ($back >= 0)
{
	if (isset($map->map[$back]->ico))
		$icon = $map->map[$back]->ico;
	else
		$icon = 'icon/back.gif';

	$content .= (
		'<HR>' .
		'<A HREF="' . me($back) . '"><IMG SRC="gfx/' . $icon . '" WIDTH=16 HEIGHT=16 BORDER=0></A><FONT FACE="Arial,Sans Serif" SIZE=-1>&nbsp;<A HREF="' . me($back) . '">Back&nbsp;to&nbsp;' . str_replace(' ', '&nbsp;', $map->map[$back]->name) . '</A></FONT>'
	);
}

//_[footer html of menu]______________________________________________________
$content .= (

	'</TD></TR>' .
	'<TR><TD ALIGN=LEFT VALIGN=BOTTOM BGCOLOR=C0C0C0>' . rndilnk() . '</TD><TD ALIGN=LEFT BGCOLOR=C0C0C0><FONT FACE="MS Sans Serif, Arial" SIZE=-2>' .
		str_replace(' ', '&nbsp;', $page->quote) .
	'</FONT></TD><TD ALIGN=RIGHT VALIGN=BOTTOM BGCOLOR=C0C0C0><IMG WIDTH=16 HEIGHT=16 SRC="gfx/table/cornpull.gif"></TD></TR>' .
	'</TABLE></TD><TD VALIGN=TOP ALIGN=LEFT WIDTH=100%><FONT FACE="' . $contentfont . '">'
);

/*****************************************************************************

	Generate Footer

*****************************************************************************/

$footer =
	'</FONT></TD></TR></TABLE>'	.'<TABLE WIDTH=100% BORDER=2 CELLPADDING=0 CELLSPACING=0 BGCOLOR=C0C0C0><TD>' .
	'<TABLE WIDTH=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>' .
		'<TR><TD ALIGN=CENTER>' .
		'<FONT SIZE=-1 FACE="Arial Narrow"><B>' .
			'&copy;opyright 1998, 1999, 2000, 2001++ by Neil C. Obremski' .
		'</B></FONT>' .
		'<BR>' .
		'<I><FONT SIZE=-2 FACE="Arial">Any unauthorized distribution of this site, and/or it\'s content, in any form is strictly prohibited.</FONT></I>' .
		'</TD></TR>' .
		'<TR><TD ALIGN=CENTER>' .
			$banner2 .
		'</TD></TR>' .
	'</TABLE></TD></TABLE>' .
	'</BODY>' .
	'</HTML>'
;

/*****************************************************************************

	Output

*****************************************************************************/

mt_srand ((double) microtime() * 1000000);
echo($header . $content);

if ($page->child > 0 && @is_file($srcfile) == false)
{
	$srcfile .= '_desc.';
	$srcfile .= $page->t;
}

if (isset($du) && $du != '')
{
	if (@is_file($srcfile))
	{
		echo('Click the link below to view or download the file.<BR><BR><A HREF="' . $srcdir . $du . '">' . $du . '</A>');
	}
	else
	{
		echo('Couldn\'t find "' . $srcdir . $du . '".  Sorry.');
	}
}
else if (@is_file($srcfile) == false)
{
	// file not found
}
else switch ($page->t)
{
	case 'in':
	{
		$inp = implode('', file($srcfile));
		$inp = str_replace('@rndilnk@', rndilnk(), $inp);

		while (($stof = strpos($inp, '"@')) != false)
		{
			$stof ++;
			$endof = strpos($inp, '@"') + 1;
			$uniq = substr($inp, $stof+1, $endof - $stof - 2);

			for ($i = 0; $i < $map->len; $i++)
			{
				if (isset($map->map[$i]->u) && $map->map[$i]->u == $uniq)
				{
					break;
				}
			}
			if ($i >= $map->len)
				$i = 0;

			$inp = substr_replace($inp, me($i), $stof, $endof - $stof);
		}

		echo($inp);

	}	break;
	case 'exe':
	case 'bat':
	case 'zip':
	{
		$fsz = filesize($srcfile) / 1024;
		$fsz *= 10;
		$fsz = (int)$fsz;
		$fsz /= 10;
		echo('<A HREF="' . $srcdir . $page->id . '">Download ' . $page->name . '</A> (' . $fsz . 'k)');
	}	break;
	case 'php':
	{
		include($srcfile);
	}	break;
	default:
	{
		include('_' . $page->t . '.php');
		break;
	}
}

echo($footer);

?>