'*****************************************************************
'* ASCII Muscle Man / By Neil Obremski / 1997                    *
'*****************************************************************

'_[@beg@ new code added 20 FEB 2001 for timing]______________________________
DECLARE SUB ini.timer (fps AS LONG)
DECLARE SUB do.timer ()
DIM SHARED cps AS LONG, stoptime AS INTEGER
CONST TIMER.PRECISION = 2
RANDOMIZE TIMER
ini.timer 24
'_[@end@ new code added 20 FEB 2001 for timing]______________________________

DIM image$(20, 10), rollcamera(300)

ConfigureVariables:
   frame = 0            ' Variable for keeping track of frames
   'delay = .001         ' The smaller the number the longer the delay
   a$ = ""              ' Keeps track of keyboard input
 
   ' The following is the frame order for the animation
   ' Changing the numbers could result in strange things
   ' PART #1 - Swing Arms
   rollcamera(1) = 1
   rollcamera(2) = 2
   rollcamera(3) = 3
   rollcamera(4) = 4
   rollcamera(5) = 5
   rollcamera(6) = 6
   rollcamera(7) = 5
   rollcamera(8) = 4
   rollcamera(9) = 3
   rollcamera(10) = 2
   rollcamera(11) = 1
   ' PART #2 - Squat Down
   rollcamera(12) = 7
   rollcamera(13) = 8
   rollcamera(14) = 7
   rollcamera(15) = 1
   ' PART #3 - Rotate Arms
   rollcamera(16) = 7
   rollcamera(17) = 9
   rollcamera(18) = 10
   rollcamera(19) = 11
   rollcamera(20) = 10
   rollcamera(21) = 9
   rollcamera(22) = 10
   rollcamera(23) = 11
   rollcamera(24) = 10
   rollcamera(25) = 9
   rollcamera(26) = 7
   rollcamera(27) = 1
   rollcamera(28) = 2
   rollcamera(29) = 3
   rollcamera(30) = 4
   ' PART #4 - Stomp Feet
   rollcamera(31) = 12
   rollcamera(32) = 4
   rollcamera(33) = 13
   rollcamera(34) = 4
   rollcamera(35) = 12
   rollcamera(36) = 4
   rollcamera(37) = 13
   rollcamera(38) = 4
   rollcamera(39) = 5
   rollcamera(40) = 6
   ' PART #5 - Sway
   rollcamera(41) = 6
   rollcamera(42) = 14
   rollcamera(43) = 6
   rollcamera(44) = 15
   rollcamera(45) = 6
   rollcamera(46) = 14
   rollcamera(47) = 6
   rollcamera(48) = 15
   rollcamera(49) = 6
   rollcamera(50) = 5
   rollcamera(51) = 4
   rollcamera(52) = 3
   rollcamera(53) = 2
   rollcamera(54) = 1
             
   rolltime = 54              ' The number of frames of animation.
                              ' Correlates directly with rollcamera()

   ' The actual frames!
   image$(1, 1) = "o_._ _O_ _._o"
   image$(1, 2) = "    `\ /'    "
   image$(1, 3) = "      U      "
   image$(1, 4) = "    ./ \.    "
   image$(1, 5) = "    |   |    "
   image$(1, 6) = "   ~~~ ~~~   "

   image$(2, 1) = "   _ _O_ _   "
   image$(2, 2) = " o/ `\ /' \o "
   image$(2, 3) = "      U      "
   image$(2, 4) = "    ./ \.    "
   image$(2, 5) = "    |   |    "
   image$(2, 6) = "   ~~~ ~~~   "
  
   image$(3, 1) = "     _O_     "
   image$(3, 2) = "  ,/`\ /'\,  "
   image$(3, 3) = " /o   U   o\ "
   image$(3, 4) = "    ./ \.    "
   image$(3, 5) = "    |   |    "
   image$(3, 6) = "   ~~~ ~~~   "
  
   image$(4, 1) = "     _O_     "
   image$(4, 2) = "  ,/`\ /'\,  "
   image$(4, 3) = "  |o  U  o|  "
   image$(4, 4) = "    ./ \.    "
   image$(4, 5) = "    |   |    "
   image$(4, 6) = "   ~~~ ~~~   "

   image$(5, 1) = "     _O_     "
   image$(5, 2) = "   /`\ /'\   "
   image$(5, 3) = "  `\o U o/'  "
   image$(5, 4) = "    ./ \.    "
   image$(5, 5) = "    |   |    "
   image$(5, 6) = "   ~~~ ~~~   "

   image$(6, 1) = "     _O_     "
   image$(6, 2) = "   /`\ /'\   "
   image$(6, 3) = "   `\oUo/'   "
   image$(6, 4) = "    ./ \.    "
   image$(6, 5) = "    |   |    "
   image$(6, 6) = "   ~~~ ~~~   "

   image$(7, 1) = "o           o"
   image$(7, 2) = " \._ _O_ _./ "
   image$(7, 3) = "    `\ /'    "
   image$(7, 4) = "    ._U_.    "
   image$(7, 5) = "    |   |    "
   image$(7, 6) = "   ~~~ ~~~   "
  
   image$(8, 1) = "o           o"
   image$(8, 2) = " \         / "
   image$(8, 3) = "  `\ _O_ /'  "
   image$(8, 4) = "    `\_/'    "
   image$(8, 5) = "    |` '|    "
   image$(8, 6) = "   ~~~ ~~~   "
  
   image$(9, 1) = "o            "
   image$(9, 2) = " \._ _O_ _   "
   image$(9, 3) = "    `\ /' '\o"
   image$(9, 4) = "    ._U_.    "
   image$(9, 5) = "    |   |    "
   image$(9, 6) = "   ~~~ ~~~   "
  
   image$(10, 1) = "             "
   image$(10, 2) = "o_._ _O_ _._o"
   image$(10, 3) = "    `\ /'    "
   image$(10, 4) = "    ._U_.    "
   image$(10, 5) = "    |   |    "
   image$(10, 6) = "   ~~~ ~~~   "
  
   image$(11, 1) = "            o"
   image$(11, 2) = "   _ _O_ _./ "
   image$(11, 3) = "o/` `\ /'    "
   image$(11, 4) = "    ._U_.    "
   image$(11, 5) = "    |   |    "
   image$(11, 6) = "   ~~~ ~~~   "
  
   image$(12, 1) = "     _O_     "
   image$(12, 2) = "  ,/`\ /'\,  "
   image$(12, 3) = "  |o  U_. o\ "
   image$(12, 4) = "    ./  |    "
   image$(12, 5) = "    |  ~~~   "
   image$(12, 6) = "   ~~~       "

   image$(13, 1) = "     _O_     "
   image$(13, 2) = "  ,/`\ /'\,  "
   image$(13, 3) = " /o ._U  o|  "
   image$(13, 4) = "    |  \.    "
   image$(13, 5) = "   ~~~  |    "
   image$(13, 6) = "       ~~~   "

   image$(14, 1) = "    _O_      "
   image$(14, 2) = "  /`\ /'\    "
   image$(14, 3) = "  `\oUo/'    "
   image$(14, 4) = "    / \      "
   image$(14, 5) = "   `\  `\    "
   image$(14, 6) = "   ~~~ ~~~   "

   image$(15, 1) = "      _O_    "
   image$(15, 2) = "    /`\ /'\  "
   image$(15, 3) = "    `\oUo/'  "
   image$(15, 4) = "     ,/ \    "
   image$(15, 5) = "    /   /'   "
   image$(15, 6) = "   ~~~ ~~~   "

   CLS

StartLabel:

   ' Let's make it possible to escape with any key stroke
   a$ = INKEY$
   IF a$ > CHR$(0) THEN
      SYSTEM
   END IF

   ' Increment Muscle Man frame
   frame = frame + 1
   IF frame > rolltime THEN frame = 1

   ' Draw "the man"
   GOSUB DrawMuscleMan

   ' Delay (make some time)
   LOCATE 1, 20
   PRINT "The ASCII Muscle Man of Wonder!"
   LOCATE 2, 20
   PRINT "Watch as he displays his prowess!"
   LOCATE 4, 20
   PRINT "           -By Neil Obremski-"
 
   do.timer ' new (20 feb 2001)

   ' Re-route to beginning of program
   GOTO StartLabel

DrawMuscleMan:
   LOCATE 1, 1
   PRINT "ͻ"
   FOR i = 1 TO 6
      PRINT "" + image$(rollcamera(frame), i) + ""
   NEXT i
   PRINT "ͼ"
   RETURN

Finish:
  stoptime = 1
  RETURN

SUB do.timer

  STATIC t AS LONG

  t = 0
  WHILE (t < cps)
    t = t + 1
  WEND

END SUB

SUB ini.timer (fps AS LONG)
  DIM milli AS LONG, gettime AS LONG

  stoptime = 0
  milli = 1
  ON TIMER(TIMER.PRECISION) GOSUB Finish
  TIMER ON
  WHILE (stoptime = 0)
    milli = milli + 1
  WEND
  TIMER OFF

  cps = milli / TIMER.PRECISION / fps

END SUB

