//file: user.cc
//		implementation file for class user.

#include <iostream.h>
#include <stdlib.h>
#include <ctype.h>
#include "utility.h"
#include "user.h"

User :: User() {
         ShowMenu();
}

Bool User :: IsLegal(char cmd) {
   if(   (cmd == 'C') || (cmd == 'B') || (cmd == 'O') ||
         (cmd == 'I') || (cmd == 'X') || (cmd == 'M') ||
         (cmd == 'A') || (cmd == 'N') || (cmd == 'P') ||
         (cmd == 'S') )
      return True;
   else
      return False;

}

void User :: ShowMenu() {
   static char *menu[] = { "\n\tC:\tshow all library Cards",
                           "\tB:\tshow all library Books",
                           "\tO:\tcheck Out a book",
                           "\tI:\tcheck In a book",
                           "\tM:\tdisplay this Menu",
                           "\tX:\teXit and close the library",
                           "\tA:\tAdd new book",
                           "\tN:\tadd New card",
                           "\tP:\tPrint book information",
                           "\tS:\tSend book to bindery",
                           NULL
                        };

   int k = 0;
   cout << "   Available Commands: " << endl;
   while( menu[k] )
      cout << menu[k++] << endl;

}

char User :: GetCommand() {
   char cmd;

   while (1) {
      cout << "\n>";
      cin >> cmd;

      cmd = toupper(cmd);

      if( IsLegal(cmd) ) {

         if( cmd == 'M' )
            ShowMenu();
         else
            return cmd;
      }
      else {
         cout << "\n*** Unrecognized command+++." << endl;
         cout << "Type M to see menu." << endl;
      }
   }
}